unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, BufDataset, DB, Forms, Controls, Graphics, Dialogs,
  DBGrids, StdCtrls, DBCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    BufDataset1: TBufDataset;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    procedure BufDataset1BeforePost(DataSet: TDataSet);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
  private
    procedure OnValidateNonNegNumber(Sender: TField);

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  Bufdataset1.FileName := 'test.db';
  if not FileExists(Bufdataset1.FileName) then
  begin
    BufDataset1.FieldDefs.Add('x', ftFloat);
    BufDataset1.FieldDefs.Add('y', ftFloat);
    BufDataset1.CreateDataset;

    Bufdataset1.Append;
    BufDataset1.FieldByName('x').AsFloat := 0.12;
    BufDataset1.FieldByName('y').AsFloat := 0.36;
    BufDataset1.Post;

    Bufdataset1.Append;
    BufDataset1.FieldByName('x').AsFloat := 0.21;
    BufDataset1.FieldByName('y').AsFloat := 0.19;
    BufDataset1.Post;
  end;
  BufDataset1.Open;
  BufDataset1.FieldByName('x').OnValidate := @OnValidateNonNegNumber;
  BufDataset1.FieldByName('y').OnValidate := @OnValidateNonNegNumber;
end;

procedure TForm1.OnValidateNonNegNumber(Sender: TField);
begin
  if ((Sender.FieldName = 'x') or (Sender.FieldName = 'y')) then
  begin
    if Sender.AsFloat < 0 then
    begin
      ShowMessage('Feld ' + Sender.FieldName + ' darf nicht kleiner als Null sein.');
      Abort;
    end;
  end;
end;

procedure TForm1.BufDataset1BeforePost(DataSet: TDataSet);
var
  x, y: Double;
begin
  x := BufDataset1.FieldByName('x').AsFloat;
  y := BufDataset1.fieldByName('y').AsFloat;
  if sqr(x) + sqr(y) > 2 then begin
    ShowMessage('Die Summe der Quadrate von x und y darf nicht größer als Zwei sein.');
    Abort;
  end;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var
  res: TModalresult;
begin
  if BufDataset1.State in dsEditModes then
  begin
    res := MessageDlg('Die Datenbank wird gerade bearbeitet. Speichern?',
      mtInformation, [mbYes, mbNo, mbCancel], 0);
    case res of
      mrYes: BufDataset1.Post;
      mrNo: BufDataset1.Cancel;
      mrCancel: CanClose := false;
    end;
  end;
end;

end.

